## vecgeom 1.1.18%2Bdfsg

=== persistency/gdml/test/CMakeLists.txt ===
#    \file CMakeLists.txt
#    \brief tests the library for interoperation of VecGeom with GDML
#
#    \authors Author:  Dmitry Savin
#
#    \license Distributed under the Apache license 2.0
# Executable for Backend/Frontend/Middleware/Schema types
foreach(_vgdml_test TestXercesBackend TestXercesFrontend TestXercesMiddleware ReadMiddlewareData
                    TestVGDMLAuxiliary TestVGDMLNavigation TestVGDMLVolumeAuxiliaryInfo)
  add_executable(${_vgdml_test} ${_vgdml_test}/${_vgdml_test}.cpp)
  # Not 100% clear that USERKERNELLIB is needed
  target_link_libraries(${_vgdml_test} vgdml ${USERKERNELLIB})
endforeach()

# Tests of VGDML's types for the GDML schema and translations
add_test(NAME TestVGDMLAuxiliary COMMAND TestVGDMLAuxiliary)
add_test(NAME TestVGDMLVolumeAuxiliaryInfo COMMAND TestVGDMLVolumeAuxiliaryInfo "${CMAKE_CURRENT_SOURCE_DIR}/../gdmls/auxiliary.gdml" )

# Add tests for each type with needed input GDML file
# - Backend
file(GLOB GDMLS ${CMAKE_CURRENT_SOURCE_DIR}/../gdmls/*.gdml)
foreach(GDML ${GDMLS})
  get_filename_component(BASENAMEGDML ${GDML} NAME)
  add_test(NAME TestXercesBackend-${BASENAMEGDML} COMMAND TestXercesBackend ${GDML})
endforeach()

# - Middleware
foreach(BASENAMEGDML oneOrb oneSphere oneTorus oneBox oneTube oneConeSegment oneParallelepiped oneTrapezoid oneParaboloid oneGeneralTrapezoid oneHyperbolicTube oneCutTube aConstant twoBoxes aPosition aRotation solidIntersection solidSubtraction solidUnion onePolycone onePolyhedron cms2018)
  set(GDMLFILE ${CMAKE_CURRENT_SOURCE_DIR}/../gdmls/${BASENAMEGDML}.gdml)
  add_test(NAME TestXercesMiddleware-${BASENAMEGDML} COMMAND TestXercesMiddleware ${GDMLFILE})
endforeach()

# - Navigation tests using GDML input file

foreach(NAVIGATOR SimpleABBoxNavigator HybridNavigator BVHNavigator)
  foreach(GDML trackML cms2018)
    set(GDML_FILE ${CMAKE_CURRENT_SOURCE_DIR}/../gdmls/${GDML}.gdml)
    add_test(NAME Test${NAVIGATOR}-${GDML}
      COMMAND TestVGDMLNavigation -i 10 -n ${NAVIGATOR} ${GDML_FILE})
  endforeach()
endforeach()

## vecgeom 1.1.18+dfsg

=== CMakeLists.txt ===
# - Setup the project
cmake_minimum_required(VERSION 3.8...3.19)
if(${CMAKE_VERSION} VERSION_LESS 3.12)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
endif()

include(cmake/modules/RecordCmdLine.cmake)
include(ExternalProject)

project(VecGeom VERSION 1.1.18)

################################################################################
# - Core CMake settings
# - Core/Custom modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake/modules)
include(MacroUtilities)
include(CMakeDependentOption)
include(IntelCompileFeatures)

# - Though we check for some absolute paths, ensure there are no others
set(CMAKE_ERROR_ON_ABSOLUTE_INSTALL_DESTINATION ON)

# - Never export to or search in user/system package registry
set(CMAKE_EXPORT_NO_PACKAGE_REGISTRY ON)
set(CMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY ON)
set(CMAKE_FIND_PACKAGE_NO_SYSTEM_PACKAGE_REGISTRY ON)

# - Force project directories to appear first in any list of includes
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

# - Only relink shared libs when interface changes
set(CMAKE_LINK_DEPENDS_NO_SHARED ON)

# - Only report newly installed files
set(CMAKE_INSTALL_MESSAGE LAZY)

################################################################################
# - Core build settings
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "No build type selected, default to Release")
  set(CMAKE_BUILD_TYPE "Release")
endif()
string(TOUPPER ${CMAKE_BUILD_TYPE} _build_type)

# - Setting the C++ compiler to use
set("${CMAKE_CXX_COMPILER_ID}" TRUE CACHE STRING "C++ Compiler")
if(NOT GNU AND NOT Clang AND NOT AppleClang AND NOT Intel AND NOT IntelLLVM)
  message(WARNING "Unsupported compiler. Build will likely fail.")
endif()

# - C++ standard and extensions
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 11 CACHE STRING "C++ ISO Standard")
set(CMAKE_CXX_STANDARD_REQUIRED True)

# Use ccache if available ( to avoid recompilation on branch switches )
find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
  message(STATUS "found ccache")
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif()

# - Basic library settings
# Build statics with Position Independent Code
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Review this as this is strictly incorrect for macOS (likely ROOT-ism)
if(APPLE)
  set(CMAKE_SHARED_LIBRARY_SUFFIX ".so")
endif()

# Install paths
include(GNUInstallDirs)
# Add a path for CMake config files (immutable)
set(CMAKE_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake")
set(CMAKE_INSTALL_FULL_CMAKEDIR "${CMAKE_INSTALL_FULL_LIBDIR}/cmake")

# Add uninstall target if required
if(NOT TARGET uninstall)
  configure_file(cmake/cmake_uninstall.cmake.in
    "${PROJECT_BINARY_DIR}/cmake_uninstall.cmake"
    @ONLY)

  add_custom_target(uninstall
    COMMAND "${CMAKE_COMMAND}" -P "${PROJECT_BINARY_DIR}/cmake_uninstall.cmake"
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}")
endif()

################################################################################
# Configuration options
# - ISA
set(VECGEOM_ISAS empty)
if(CMAKE_SYSTEM_PROCESSOR MATCHES "(i686|x86_64)")
  set(VECGEOM_ISAS sse2 sse3 ssse3 sse4.1 sse4.2 avx avx2 native empty)
endif()

enum_option(VECGEOM_VECTOR DOC "Vector instruction set to be used"
  TYPE STRING
  VALUES ${VECGEOM_ISAS}
  CASE_INSENSITIVE)

# - ISA Backend
set(VECGEOM_BACKENDS scalar vc)
enum_option(BACKEND DOC "Vector backend API to be used"
  TYPE STRING
  VALUES ${VECGEOM_BACKENDS}
  CASE_INSENSITIVE)

# Case adjustment because pass to VecCore components is
if(BACKEND STREQUAL "scalar")
  set(BACKEND "Scalar")
elseif(BACKEND STREQUAL "vc")
  set(BACKEND "Vc")
endif()

# Configure backend for export to VecGeom's Config.h and setting up VecCore
string(TOUPPER "${BACKEND}" _BACKEND_UP)
set(VECGEOM_${_BACKEND_UP} True)
message(STATUS "Configuring with ${BACKEND} vector backend")

if("${BACKEND}" MATCHES "Vc")
  set(VecCore_COMPONENTS ${VecCore_COMPONENTS} ${BACKEND})
endif()

# - Core
option(BUILTIN_VECCORE "Build VecCore and its dependencies from source" OFF)

# - Precision
option(SINGLE_PRECISION "Use single precision throughout the package" OFF)
if (SINGLE_PRECISION)
  message(STATUS "VecGeom compiles in single precision mode.")
  set(VECGEOM_FLOAT_PRECISION ON)
endif()

option(CUDA "Enable compilation for CUDA." OFF)
cmake_dependent_option(CUDA_VOLUME_SPECIALIZATION "Use specialized volumes for CUDA." OFF "CUDA" OFF)
cmake_dependent_option(CUDA_SEPARABLE_COMPILATION "Compile CUDA objects with separable compilation enabled." ON "CUDA" OFF)
cmake_dependent_option(CUDA_USE_STATIC_CUDA_RUNTIME "Use the static version of the CUDA runtime library if available" OFF "CUDA" OFF)

if(CUDA)
  set(VECGEOM_ENABLE_CUDA ON)
  if(CUDA_VOLUME_SPECIALIZATION)
    set(VECGEOM_CUDA_VOLUME_SPECIALIZATION ON)
  endif()

  set(CUDA_ARCH 30 CACHE STRING "CUDA device architecture.")
  set(CUDA_ARCH "-arch=sm_${CUDA_ARCH}")

  set(VecCore_COMPONENTS ${VecCore_COMPONENTS} "CUDA")
endif()

option(NO_SPECIALIZATION "Disable specialization of volumes." ON)
if(NO_SPECIALIZATION)
  set(VECGEOM_NO_SPECIALIZATION ON)
endif()

option(PLANESHELL "Enable the use of PlaneShell class for the trapezoid." ON)
if(NOT PLANESHELL)
  set(VECGEOM_PLANESHELL_DISABLE TRUE)
endif()

option(QUADRILATERAL_ACCELERATION "Enable SIMD vectorization when looping over quadrilaterals (in Polyhedron)." ON)
if(QUADRILATERAL_ACCELERATION)
  set(VECGEOM_QUADRILATERALS_VC ON)
endif()

option(DISTANCE_DEBUG "Enable comparison of calculated distances againt ROOT/Geant4 behind the scenes" OFF)
if(DISTANCE_DEBUG)
  set(VECGEOM_DISTANCE_DEBUG ON)
endif()

option(INPLACE_TRANSFORMATIONS "Put transformation as members rather than pointers into PlacedVolume objects" ON)
if(INPLACE_TRANSFORMATIONS)
  set(VECGEOM_INPLACE_TRANSFORMATIONS ON)
endif()

option(USE_INDEXEDNAVSTATES "Use indices rather than volume pointers in NavigationState objects" ON)
if(USE_INDEXEDNAVSTATES)
  set(VECGEOM_USE_INDEXEDNAVSTATES ON)
endif()

option(USE_NAVINDEX "Use navigation index table and states" OFF)
if(CUDA)
  ### CUDA=ON requires NAVINDEX
  message(STATUS CUDA=ON implies USE_NAVINDEX=ON)
  set(USE_NAVINDEX ON)
endif()
if(USE_NAVINDEX)
  set(VECGEOM_USE_NAVINDEX ON)
endif()

option(GDML "Enable GDML persistency. Requires Xerces-C" OFF)
if(GDML)
  set(VECGEOM_GDML ON)
endif()
option(GDMLDEBUG "Enable additional debug information in GDML module" OFF)

option(EMBREE "Enable Intel Embree" OFF)
if(EMBREE)
  set(VECGEOM_EMBREE ON)
endif()

option(USE_CACHED_TRANSFORMATIONS "Use cached transformations in navigation states" OFF)
if(USE_CACHED_TRANSFORMATIONS)
  set(VECGEOM_CACHED_TRANS ON)
endif()

option(FAST_MATH "Enable the -ffast-math compiler option in Release builds" OFF)

################################################################################
# - Testing, unit, coverage, benchmarking, validation etc
include(CTest)

# TODO: not completely set up. Will build VG+tests with correct flags/links, but no report gen.
cmake_dependent_option(COVERAGE_TESTING "Enable coverage testing flags" OFF "BUILD_TESTING" OFF)

# TODO: Check use of this option, not totally clear on use
cmake_dependent_option(VALIDATION "Enable validation tests from CMS geometry" OFF "BUILD_TESTING" OFF)

# Static tests build/use clang-tidy, so require compile commands for VecGeom to be exported
cmake_dependent_option(STATIC_ANALYSIS "Enable static analysis/testing on VecGeom" OFF "BUILD_TESTING" OFF)
if(STATIC_ANALYSIS)
  set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
endif()

# Following options result in changes to VecGeom API/ABI, but are strictly only for testing (AFAK)
cmake_dependent_option(VTUNE "Enable the use of profiler Vtune" OFF "BUILD_TESTING" OFF)
if(VTUNE)
  set(VECGEOM_VTUNE ON)
endif()

# These are also testing only
cmake_dependent_option(ROOT "Enable testing using ROOT" OFF "BUILD_TESTING" OFF)
if(ROOT)
  set(VECGEOM_ROOT ON)
endif()

cmake_dependent_option(GEANT4 "Enable testing using Geant4" OFF "BUILD_TESTING" OFF)
if(GEANT4)
  set(VECGEOM_GEANT4 ON)
endif()

cmake_dependent_option(BENCHMARK "Enable benchmark/performance tests" OFF "BUILD_TESTING" OFF)
if(BENCHMARK)
  set(VECGEOM_BENCHMARK ON)
endif()


################################################################################
# Minimum version of VecCore we need.
set(VecCore_VERSION "0.8.0")

# Let's see if we can find VecCore
if(NOT BUILTIN_VECCORE)
  # Find VecCore with selected components turned on (CUDA and backend)
  find_package(VecCore ${VecCore_VERSION} QUIET COMPONENTS ${VecCore_COMPONENTS})
  if(NOT VecCore_FOUND)
    # This is forced because otherwise re-cmake will setup non-builtin VecCore
    set(BUILTIN_VECCORE ON CACHE BOOL "Build VecCore and its dependencies from source" FORCE)
  endif()
endif()

# Have to recheck because the above may re-set the variable
if(BUILTIN_VECCORE)
  include(BuiltinVecCore)
endif()

# Find VecCore with selected components turned on (CUDA and backend)
find_package(VecCore ${VecCore_VERSION} REQUIRED COMPONENTS ${VecCore_COMPONENTS})

# Should no longer need this as VecCore provides usage requirements
#include_directories(${VecCore_INCLUDE_DIRS})
set(VECGEOM_LIBRARIES_EXTERNAL ${VECGEOM_LIBRARIES_EXTERNAL} VecCore::VecCore)

################################################################################
# - Compiler Flags/Settings for each build type
# We do this here as flags are dependent on chosen ISA
# Flags will also be forwarded by CUDA when compiling C++.
set(VECGEOM_ERROR_LIMIT 20 CACHE STRING "Limit number of errors output by compiler")
mark_as_advanced(VECGEOM_ERROR_LIMIT)

if(GNU)
  set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -Wall -fmax-errors=${VECGEOM_ERROR_LIMIT}")

  if(CMAKE_BUILD_TYPE MATCHES Debug)
     set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -ggdb -O0")
  else()
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -ftree-vectorize -finline-limit=10000000")
    if(FAST_MATH)
      set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -ffast-math")
    endif()
  endif()

  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "7")
    set(VECGEOM_COMPILATION_FLAGS "${VECGEOM_COMPILATION_FLAGS} -faligned-new")
  endif()

  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "4.9")
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -fdiagnostics-color=auto")
  endif()

elseif(Intel)
  set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -Wall -fmax-errors=${VECGEOM_ERROR_LIMIT}")

  if(CMAKE_BUILD_TYPE MATCHES Debug)
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -ggdb -O0")
  else()
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -fno-alias")
  endif()

  if(NOT FAST_MATH)
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -fp-model precise")
  endif()

elseif(IntelLLVM)
  set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -Wall -fmax-errors=${VECGEOM_ERROR_LIMIT}")

  if(CMAKE_BUILD_TYPE MATCHES Debug)
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -ggdb -O0")
  endif()

  if(FAST_MATH)
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -ffast-math")
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -Wno-tautological-compare")
  else()
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -fno-fast-math")
  endif()

elseif(Clang OR AppleClang)
  set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -Wall -ferror-limit=${VECGEOM_ERROR_LIMIT}")

  if(CMAKE_BUILD_TYPE MATCHES Debug)
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS}  -ggdb -O0")
  else()
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -ftree-vectorize")
    if(FAST_MATH)
      set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -ffast-math")
    endif()
  endif()

  # Whilst we don't test clang < 4, it is used to build the custom static
  # analysis tools, and this causes it to barf...
  if(CMAKE_CXX_COMPILER_VERSION GREATER_EQUAL "4")
   set(VECGEOM_COMPILATION_FLAGS "${VECGEOM_COMPILATION_FLAGS} -faligned-new")
  endif()
endif()

# - Additional flags for coverage testing support
if(COVERAGE_TESTING)
  if(GNU)
    set(VECGEOM_CXX_FLAGS "${VECGEOM_CXX_FLAGS} -fprofile-arcs -ftest-coverage")

=== test/CMakeLists.txt ===
################################################################################
## TESTING
################################################################################
# Helper Macros/Functions
macro(build_executables EXECUTABLES)
  foreach(EXECUTABLE ${EXECUTABLES})
    get_filename_component(TARGET_NAME ${EXECUTABLE} NAME_WE)
    add_executable(${TARGET_NAME} ${EXECUTABLE})
    # Link to CMAKE_DL_LIBS needed for globalbenchmarks/NavigationKernelBenchmarker.cpp
    # - No cost to link to others.
    target_link_libraries(${TARGET_NAME} ${VECGEOM_LIBRARIES} ${USERKERNELLIB} ${CMAKE_DL_LIBS})
  endforeach()
endmacro()

function(add_to_ctest EXECUTABLES)
  foreach(EXECUTABLE ${EXECUTABLES})
    get_filename_component(TARGET_NAME ${EXECUTABLE} NAME_WE)
    add_test(${TARGET_NAME} ${TARGET_NAME})
  endforeach()
endfunction()

# actual function for managing the download
function(DOWNLOAD_IF_NOT_INSTALLED FILE_URL LOCALFILE TARGETPATH MD5HASH )
  set(FILENAME "${TARGETPATH}/${LOCALFILE}")
  if(EXISTS "${FILENAME}")
    file(MD5 "${FILENAME}" MD5ACTUAL)
    if(MD5ACTUAL STREQUAL MD5HASH)
      return()
    else()
      message(WARNING "Hash not correct for data file ${FILENAME}:\n"
        "expected: ${MD5HASH}\n"
        "actual  : ${MD5ACTUAL}\n"
        "Trying to re-download")
    endif()
  endif()

  message(STATUS "Downloading ${LOCALFILE}")
  file(DOWNLOAD ${FILE_URL} ${FILENAME} SHOW_PROGRESS EXPECTED_HASH MD5=${MD5HASH})
endfunction()
################################################################################

################################################################################
# Download data if required
message(STATUS "Checking data files required for tests")
if(VECGEOM_ROOT)
  download_if_not_installed("https://cernbox.cern.ch/index.php/s/pn2UkCtloi7i0xy/download"
    "cms2015.root"
    "${CMAKE_CURRENT_BINARY_DIR}"
    "fb3ede867532b372c5e6f7138d00c07e")
  download_if_not_installed("https://cernbox.cern.ch/index.php/s/dTChF8iKEUQHMxo/download"
    "ExN03.root"
    "${CMAKE_CURRENT_BINARY_DIR}"
    "b6b0cfdd5035117171bfe1b7f1f40c3f")
endif()
################################################################################
# Define executables
################################################################################
# - Dedicated Benchmark tests
if(VECGEOM_BENCHMARK)
  add_subdirectory(benchmark)
  build_executables("${TEST_EXECUTABLES_BENCHMARK}")
  add_to_ctest("${CTESTS_BENCHMARK}")
endif()

################################################################################
# - Static Analysis tests
if(STATIC_ANALYSIS)
  add_subdirectory(static_analysis)
endif()

################################################################################
# - Core Tests
set(TEST_EXECUTABLES_CORE
  core/TestVoxelHashMap.cpp
  core/SafetyEstimatorTest.cpp
  core/ContainerTest.cpp
  core/create_geometry.cpp
  core/BitSetTest.cpp
  core/PlanesTest.cpp
  core/QuadrilateralTest.cpp
  # core/SOATest.cpp
  core/Transformation3DTest.cpp
  # core/boolminustest.cpp
  # core/boolminustest2.cpp
  core/PhiWedgeTest.cpp
  core/ThetaConeTest.cpp
  core/TestConvexity.cpp
  core/BooleanConvexityTest.cpp
  unit_tests/TestEstimateSurfaceArea.cpp
  unit_tests/TestVecGeomPolycone.cpp
  core/TestSExtru.cpp
  # to be enabled when running cleanly
  unit_tests/TestBooleans.cpp
  core/AssemblyTest.cpp
  core/TestMakeInstance.cpp
  #  services/CompNavStatePools.cpp
  core/TestMaskedAssign.cpp
  core/TestVector.cpp
  core/TestMap.cpp
  core/TestHybridBVH.cpp
  core/TestEarlyReturns.cpp
  core/CreateTessels.cpp
  core/CreateExtruded.cpp
  core/TestGeoManager.cpp)

if(USE_INDEXEDNAVSTATES)
  list(APPEND TEST_EXECUTABLES_CORE core/TestNavigationState.cpp)
endif()

if(NOT VECGEOM_ENABLE_CUDA)
  list(APPEND TEST_EXECUTABLES_CORE core/testVectorSafety.cpp)
endif()

build_executables("${TEST_EXECUTABLES_CORE}")
add_to_ctest("${TEST_EXECUTABLES_CORE}")

################################################################################
# - ROOT Tests
if(VECGEOM_ROOT)
  set(TEST_EXECUTABLES_ROOT
    core/TestNavigationStatePool.cpp
    core/BoxBoxIntersectionTest.cpp
    core/SplittedABBox.cpp
    core/TestRegions.cpp
    root/root_geometry.cpp
    root/complex_test1.cpp
    root/E03Test.cpp
    root/ImportFromRootFileTest.cpp
    root/ImportTGeoPgon.cpp
    root/TestExportToROOT.cpp
    root/ExitingOrEntering.cpp
    root/AssemblyExample.cpp
    # higher level benchmarks or executables
    globalbenchmarks/LocatePointsBenchmark.cpp
    globalbenchmarks/SafetyKernelBenchmarker.cpp
    globalbenchmarks/NavigationKernelBenchmarker.cpp
    globalbenchmarks/TraceTrack.cpp
    globalbenchmarks/XRayBenchmarkFromROOTFile.cpp
    # ???
    ${PROJECT_SOURCE_DIR}/services/NavigationSpecializerTest.cpp
    ${PROJECT_SOURCE_DIR}/services/LibraryGenerator.cpp)

  if(VECGEOM_BENCHMARK)
    list(APPEND TEST_EXECUTABLES_ROOT
      root/BenchmarkShapeFromROOTFile.cpp
      root/BenchmarkShapeFromROOTFile_WithVisualization.cpp
      root/CompareDistances.cpp
      root/GenerateSurfacePoints.cpp
      shape_tester/shapeDebug.cpp)
  endif()

  if(VECGEOM_EMBREE)
    list(APPEND TEST_EXECUTABLES_ROOT core/EmbreeManagerTest.cpp)
  endif()

  # - separate list for ROOT UNIT tests
  set(TEST_UNITTESTEXECUTABLES_ROOT
    root/complex_test1.cpp
    root/E03Test.cpp
    root/TestExportToROOT.cpp
    root/ImportTGeoPgon.cpp)

  build_executables("${TEST_EXECUTABLES_ROOT}")
  add_to_ctest("${TEST_UNITTESTEXECUTABLES_ROOT}")
endif()

################################################################################
# - Visualization tests
if(VECGEOM_ROOT)
  set(TEST_EXECUTABLES_VISUALIZATION
    visualization/VisualizeTrap.cpp
    visualization/VisualizePolycone.cpp
    visualization/VisualizePolyhedron.cpp
    visualization/VisualizeParboloid.cpp
    visualization/VisualizeCone.cpp
    # visualization/VisualizeTorus.cpp
    visualization/VisualizeTube.cpp
    visualization/VisualizeScaled.cpp
    visualization/DebugTube.cpp
    visualization/DebugPolyhedron.cpp
    visualization/VisualizeSphere.cpp
    visualization/VisualizeGenTrap.cpp
    visualization/VisualizeHype.cpp
    visualization/VisualizeParallelepiped.cpp
    visualization/VisualizeCutTube.cpp
    # visualization/VisualizeExtruded.cpp
    )

  if(NOT VECGEOM_ENABLE_CUDA)
    list(APPEND TEST_EXECUTABLES_VISUALIZATION visualization/VisualizeMultiUnion.cpp)
  endif()

  build_executables("${TEST_EXECUTABLES_VISUALIZATION}")
endif()

################################################################################
# - Shape Tests
set(TEST_EXECUTABLES_SHAPES
  unit_tests/TestBox.cpp
  unit_tests/TestCons.cpp
  unit_tests/TestGenTrap.cpp
  unit_tests/TestTube.cpp
  unit_tests/TestEllipticalTube.cpp
  unit_tests/TestEllipticalCone.cpp
  unit_tests/TestEllipsoid.cpp
  unit_tests/TestCoaxialCones.cpp
  unit_tests/TestGenericPolycone.cpp
  unit_tests/TestHype.cpp
  unit_tests/TestTrd.cpp
  unit_tests/TestTrap.cpp
  unit_tests/TestParallelepiped.cpp
  unit_tests/TestPolycone.cpp
  unit_tests/TestPolyhedra.cpp
  unit_tests/TestTet.cpp
  unit_tests/TestOrb.cpp
  unit_tests/TestSphere.cpp
  unit_tests/TestTorus2.cpp
  unit_tests/TestParaboloid.cpp
  unit_tests/TestReducedPolycone.cpp
  unit_tests/TestUtils3D.cpp)

if(NOT VECGEOM_ENABLE_CUDA)
  list(APPEND TEST_EXECUTABLES_SHAPES
    unit_tests/TestTessellated.cpp
    unit_tests/TestMesh.cpp)
endif()

build_executables("${TEST_EXECUTABLES_SHAPES}")
# add unit tests
add_test(NAME TestBox COMMAND TestBox)
add_test(NAME TestCone COMMAND TestCons)
add_test(NAME TestGenTrap COMMAND TestGenTrap)
add_test(NAME TestHype COMMAND TestHype)
add_test(NAME TestOrb COMMAND TestOrb)
add_test(NAME TestPolycone COMMAND TestPolycone)
add_test(NAME TestPolyhedra COMMAND TestPolyhedra)
add_test(NAME TestParallelepiped COMMAND TestParallelepiped)
add_test(NAME TestParaboloid COMMAND TestParaboloid)
add_test(NAME TestSphere COMMAND TestSphere)
add_test(NAME TestTet COMMAND TestTet)
add_test(NAME TestTrap COMMAND TestTrap)
add_test(NAME TestTrd COMMAND TestTrd)
add_test(NAME TestTube COMMAND TestTube)
if(NOT VECGEOM_ENABLE_CUDA)
  add_test(NAME TestTessellated COMMAND TestTessellated)
endif()

################################################################################
# - CUDA tests
if(VECGEOM_ENABLE_CUDA)
  set(TEST_EXECUTABLES_CUDA
    cuda/BVHTest.cpp
    cuda/MapTest.cpp
    cuda/MapTestClass.cpp
    cuda/GeometryTest.cpp)
  build_executables("${TEST_EXECUTABLES_CUDA}")

  add_test(NAME MapTest COMMAND MapTest)
  add_test(NAME BVHTest COMMAND BVHTest ${PROJECT_SOURCE_DIR}/persistency/gdml/gdmls/trackML.gdml)
  add_test(NAME GeometryTest COMMAND $<TARGET_FILE:GeometryTest> ${PROJECT_SOURCE_DIR}/persistency/gdml/gdmls/trackML.gdml)
  add_test(NAME cms2018-Test COMMAND $<TARGET_FILE:GeometryTest> ${PROJECT_SOURCE_DIR}/persistency/gdml/gdmls/cms2018.gdml)
endif()

################################################################################
# - Shape Tester tests
set(TEST_EXECUTABLES_SHAPETESTER
  shape_tester/shape_testBox.cpp
  shape_tester/shape_testSExtru.cpp
  shape_tester/shape_testOrb.cpp
  shape_tester/shape_testSphere.cpp
  shape_tester/shape_testCone.cpp
  shape_tester/shape_testEllipticalCone.cpp
  shape_tester/shape_testTube.cpp
  shape_tester/shape_testEllipticalTube.cpp
  shape_tester/shape_testEllipsoid.cpp
  shape_tester/shape_testHype.cpp
  shape_tester/shape_testTrd.cpp
  shape_tester/shape_testTrapezoid.cpp
  shape_tester/shape_testTet.cpp
  shape_tester/shape_testParaboloid.cpp
  shape_tester/shape_testPolycone.cpp
  shape_tester/shape_testGenericPolycone.cpp
  shape_tester/shape_testGenTrap.cpp
  shape_tester/shape_testParallelepiped.cpp
  shape_tester/convention_testTube.cpp
  shape_tester/shape_testPolyhedron.cpp
  shape_tester/shape_testTorus2.cpp
  shape_tester/shape_testCutTube.cpp
  shape_tester/shape_testExtruded.cpp
  shape_tester/shape_testMultiUnion.cpp)

if(VECGEOM_ROOT)
  list(APPEND TEST_EXECUTABLES_SHAPETESTER
    shape_tester/shape_testFromROOTFile.cpp
    shape_tester/shape_debugFromROOTFile.cpp)
endif()

if(NOT VECGEOM_ENABLE_CUDA)
  list(APPEND TEST_EXECUTABLES_SHAPETESTER shape_tester/shape_testTessellated.cpp)
endif()

if(VECGEOM_BENCHMARK)
  build_executables("${TEST_EXECUTABLES_SHAPETESTER}")
endif()


if(VALIDATION AND VECGEOM_ROOT)
  macro(add_cmsshapevalidation_test TESTNAME SHAPEFILE)
    add_test(NAME ${TESTNAME} COMMAND bash -c "${PROJECT_SOURCE_DIR}/test/scripts/RunRandomValidation ${PROJECT_BINARY_DIR}/BenchmarkShapeFromROOTFile  ${CMAKE_CURRENT_BINARY_DIR}/cms2015.root  ${PROJECT_SOURCE_DIR}/test/cmstestdata/${SHAPEFILE}" )
  endmacro()

  # Adding various shapes tests for nightlies
  add_cmsshapevalidation_test( tubevalidation cmstubes.txt )
  add_cmsshapevalidation_test( trapvalidation cmstraps.txt )
  add_cmsshapevalidation_test( polyconevalidation cmspolycones.txt )
  add_cmsshapevalidation_test( polyhedravalidation cmspolyhedra.txt )
  add_cmsshapevalidation_test( conevalidation cmscones.txt )
  add_cmsshapevalidation_test( boxvalidation cmsboxes.txt )
  #taken out due to problems: add_cmsshapevalidation_test( booleanvalidation cmsbooleans.txt )
  #taken out due to Issue-133: add_cmsshapevalidation_test( torusvalidation cmstori.txt )
endif()

=== persistency/gdml/CMakeLists.txt ===
#    \file CMakeLists.txt
#    \brief builds and tests a library for interoperation of VecGeom with GDML
#
#    \authors Author:  Dmitry Savin
#
#    \license Distributed under the Apache license 2.0

cmake_minimum_required(VERSION 3.8...3.19)
if(${CMAKE_VERSION} VERSION_LESS 3.12)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
endif()

project(vgdml)

# Find XercesC with selected components turned on (CUDA and backend)
find_package(XercesC REQUIRED)

# We are only a part of VecGeom, so only ever link to vecgeom target
# Easy to resotore this later if vgdml is re-split out
set(VECGEOM_LIBRARIES vecgeom)

if(GDMLDEBUG)
  # Only used in Middleware.cpp, and to set a constant
  add_definitions(-DGDMLDEBUG)
endif()

add_subdirectory(source)

option(GDMLTESTING "Enable testing of GDML persitency" ON)
if(GDMLTESTING)
  # enable_testing should be safe even if called at a lower level
  enable_testing()
  add_subdirectory(test)
endif()

=== test/benchmark/CMakeLists.txt ===
#define some benchmark executables
set(TEST_EXECUTABLES_BENCHMARK
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/SExtruBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ConcaveSExtruBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParaboloidBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParaboloidScriptBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParallelepipedBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/PolyhedronBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TubeBenchmark.cpp
#  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxMinusHollowTubeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxMinusHollowTubeBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxUnionHollowTubeBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxIntersectHollowTubeBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxUnionBoxBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/3LevelSubtractionBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TorusBenchmark2.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrapezoidBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrapezoidBenchmarkScript.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/OrbBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/SphereBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/HypeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TetBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrdBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ConeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/EllipticalTubeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/EllipticalConeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/EllipsoidBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/PolyconeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/GenericPolyconeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ScaledBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxScaledBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/GenTrapBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/CutTubeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TessellatedBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ExtrudedBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/MultiUnionBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/UnionFlatteningBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/globalbenchmarks/NavigationBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TestNavIndex.cpp
  PARENT_SCOPE
)

#define which ones should be run under ctest
set(THISCTESTS
  # TESTS MARKED # FAIL AND NEED ATTENTION
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/SExtruBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ConcaveSExtruBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParaboloidBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParaboloidScriptBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParallelepipedBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/PolyhedronBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TubeBenchmark.cpp
# ${PROJECT_SOURCE_DIR}/test/benchmark/BoxMinusHollowTubeBenchmark_virtual.cpp
# ${PROJECT_SOURCE_DIR}/test/benchmark/BoxUnionHollowTubeBenchmark_virtual.cpp
# ${PROJECT_SOURCE_DIR}/test/benchmark/BoxIntersectHollowTubeBenchmark_virtual.cpp
# ${PROJECT_SOURCE_DIR}/test/benchmark/BoxUnionBoxBenchmark_virtual.cpp
# ${PROJECT_SOURCE_DIR}/test/benchmark/3LevelSubtractionBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TorusBenchmark2.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrapezoidBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrapezoidBenchmarkScript.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/OrbBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/SphereBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/HypeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrdBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ConeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/GenTrapBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ScaledBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxScaledBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/CutTubeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/PolyconeBenchmark.cpp
)

# set the variable use in the parent cmake
set(CTESTS_BENCHMARK ${THISCTESTS} PARENT_SCOPE)

=== test/static_analysis/CMakeLists.txt ===
# find clang + llvm
find_package(Clang REQUIRED 3.9)

if( LLVM_FOUND )
  list(APPEND CMAKE_MODULE_PATH "${LLVM_CMAKE_DIR}")
  include(AddLLVM)

  # set the compiler flags to match llvm
  include(HandleLLVMOptions)
endif()

# Make sure that our source directory is on the current cmake module path so that
# we can include cmake files from this directory.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}")

# include Clang macros (unfortunately they are not part of the cmake installation)
# taken from llvm/clang 3.9.1
include(AddClang)

# add include directories
include_directories(${LLVM_INCLUDE_DIRS})

# verify that we have a dynamic library libClangTidy.[so|dylib]
# (otherwise we cannot hook our plugin)
find_file(CLANG_TIDY_LIB libClangTidy.so libClangTidy.dylib HINTS ${LLVM_CMAKE_DIR}/../../../lib)
if (!CLANG_TIDY_LIB)
  message (FATAL "no dynamic libClangTidy found in the llvm installation")
endif()

# Adding clang-tidy target if executable is found
find_program(CLANG_TIDY "clang-tidy" HINTS ${LLVM_CMAKE_DIR}/../../../bin)
find_program(CLANG_TIDY_SCRIPT "run-clang-tidy.py" HINTS ${CMAKE_CURRENT_SOURCE_DIR})

# add a unit test which will check clang-tidy conformance
add_test(static_code_test ${CMAKE_CURRENT_SOURCE_DIR}/RunChecks.sh
    ${PROJECT_BINARY_DIR}/test/static_analysis/libclangTidyVecGeomModule.so
    ${CLANG_TIDY}
    ${CLANG_TIDY_SCRIPT}
    ${PROJECT_BINARY_DIR}
    ${PROJECT_SOURCE_DIR}
    )

#
# plugin specific stuff starts here
#
set(LLVM_LINK_COMPONENTS support)

add_clang_library(clangTidyVecGeomModule
  SHARED

  MaskedAssignCheck.cpp
  VecGeomTidyModule.cpp

  LINK_LIBS
  clangAST
  clangASTMatchers
  clangBasic
  clangLex
  clangTidy
  clangTidyUtils
  clangTooling
  )

=== persistency/gdml/source/CMakeLists.txt ===
#    \file CMakeLists.txt
#    \brief builds a library for interoperation of VecGeom with GDML
#
#    \authors Author:  Dmitry Savin
#
#    \license Distributed under the Apache license 2.0

add_library(vgdml
  include/Auxiliary.h
  include/Backend.h
  include/Frontend.h
  include/Helper.h
  include/MaterialInfo.h
  include/RegionInfo.h
  include/Middleware.h
  src/Backend.cpp
  src/Frontend.cpp
  src/Helper.cpp
  src/Middleware.cpp
)

# Don't force this yet
#set(CMAKE_INSTALL_RPATH_USE_LINK_PATH true)

target_include_directories(vgdml PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
target_link_libraries(vgdml PUBLIC ${VECGEOM_LIBRARIES} XercesC::XercesC)

install(TARGETS vgdml EXPORT VecGeomTargets DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(DIRECTORY include/ DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/VecGeom/gdml"
  FILES_MATCHING PATTERN "*.h"
)

=== debian/changelog ===
vecgeom (1.1.18+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #988526)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Mon, 20 Dec 2021 22:54:19 +0100

=== debian/control ===
Source: vecgeom
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stephan Lachnit <stephanlachnit@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libembree-dev [any-amd64],
 libxerces-c-dev,
 vc-dev [any-amd64 any-arm any-arm64 any-i386],
 veccore-dev,
Standards-Version: 4.6.0.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/vecgeom
Vcs-Git: https://salsa.debian.org/science-team/vecgeom.git
Homepage: https://gitlab.cern.ch/VecGeom/VecGeom

Package: vecgeom-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 veccore-dev,
 vc-dev [any-amd64 any-arm any-arm64 any-i386],
 libembree-dev [any-amd64],
Description: vectorized geometry library for particle-detector simulation
 VecGeom is a geometry modeller library with hit-detection features as needed
 by particle detector simulation at the LHC and beyond.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Set to ON to build with optimizations
BUILD_OPTIMIZED=OFF

# Use Vc only on amd64, arm, arm64 and i386, else Scalar
ifeq (,$(filter $(DEB_TARGET_ARCH),amd64 arm arm64 i386))
	BACKEND=Scalar
else
	BACKEND=Vc
	ifeq ($(BUILD_OPTIMIZED),ON)
		VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=auto
	else
		VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=generic
	endif
endif

# Use Embree only on any-amd64
ifeq (,$(filter $(DEB_TARGET_ARCH),amd64))
	EMBREE=OFF
else
	EMBREE=ON
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_CXX_STANDARD=17 \
		-DBUILD_TESTING=OFF \
		-DVECGEOM_VECTOR=native \
		-DGDML=ON \
		-DEMBREE=$(EMBREE) \
		-DBACKEND=$(BACKEND) $(VC_TARGET_ARCHITECTURE) \
		-DBUILD_OPTIMIZED=$(BUILD_OPTIMIZED)

=== debian/watch ===
version=4
opts="dversionmangle=s%\+dfsg\d*$%%,repacksuffix=+dfsg" \
    https://gitlab.cern.ch/VecGeom/VecGeom/tags?sort=updated_desc archive/v?@ANY_VERSION@/.*@ARCHIVE_EXT@
